#!/usr/bin/ruby

$L = 9
$L2 = $L*$L

class Array
   def sum
      self.inject(0){|result, i| result + i }
   end
end

class Grid
  def initialize (l,a)
    @level = l
    @changed = false
    @data = Array.new(a)
    @flag = Array.new($L2){|i|
      Array.new($L){|j| 1}
    }
    killall
    puts "Recursive Level: #{@level}"
    determine
  end

  def rest
    return @data.select{|i| i== 0}.size 
  end

  def solved
    return rest == 0
  end

  def showflag
    i = 0
    @flag.each{|f|
      x = i % $L
      y = (i/$L)
      i = i + 1
    }
  end

  def pos2index(x,y)
    return y*$L + x
  end

  def kill_xline(i,n)
    i = (i / $L)*$L
    for j in 0..$L-1
      @flag[i+j][n-1] = 0
    end
  end

  def kill_yline(i,n)
    i = (i % $L)
    for j in 0..$L-1
      @flag[i+j*$L][n-1] = 0
    end
  end

  def kill_block(i,n)
    x = (i % $L)
    y = (i / $L)
    x = (x / 3) * 3
    y = (y / 3) * 3
    i = pos2index(x,y)
    for j in 0..2
      @flag[i+j*$L][n-1] = 0
      @flag[i+j*$L+1][n-1] = 0
      @flag[i+j*$L+2][n-1] = 0
    end
  end

  def killflag(i,n)
    @flag[i].fill(0)
    kill_xline(i,n)
    kill_yline(i,n)
    kill_block(i,n)
  end

  def killall
    @data.size.times{|i|
      killflag(i,@data[i]) if @data[i] != 0
    }
  end

  def place_number(i,n)
    return if @data[i] != 0
    x = (i % $L) +1
    y = i/$L + 1
    @data[i] = n + 1
    @changed = true
    killflag(i,n+1)
  end

  def check(num)
    t = Array.new($L){|i| 0}
    num.each{|i|
      $L.times{|n|
        t[n] = t[n] + @flag[i][n]
      }
    }
    while n = t.index(1)
      num.each{|i|
        if @flag[i][n] == 1
          place_number(i,n)
        end
        t[n] = 0
      }
    end
  end

  def check_line
    $L.times{|y|
      check(Array.new($L){|i| y*$L + i})
    }
    $L.times{|x|
      check(Array.new($L){|i| i*$L + x})
    }
    $L.times{|n|
      x = (n%3)*3
      y = (n/3)*3
      check(Array.new($L){|i| (i%3 + x) + (i/3 + y)*$L})
    }
  end

  def determine
    while 1
      @changed = false
      check_line
      return if @changed == false
    end
  end

  def solve_recursive(i,n)
    d = @data
    d[i] = n
    g = Grid.new(@level+1,d)
    return g.solve
  end

  def solve

    if solved
      puts "----------------------------"
      puts "Solved! at Level #{@level}"
      show
      exit 1
      return 1
    end

    min_index = 0
    min_value = 10
    @data.size.times{|i|
      if @data[i] == 0
        s = @flag[i].sum
        if min_value > s
          min_index = i
          min_value = s
        end
      end
    }
    if min_value == 0
      return 0
    end
    t = @flag[min_index]
    c = Array.new
    while n = t.index(1)
      c.push n+1
      t[n] = 0
    end
    x = min_index % $L +1
    y = min_index / $L + 1
    ans = 0
    c.each{|n|
      ans = ans + solve_recursive(min_index,n)
    }
    return ans
  end

  def show
      puts "----------------------------"
    $L.times{|i|
      j = $L*i
      k = j + $L-1
      puts @data[j..k].join(",")
    }
      puts "----------------------------"
  end
end

a = Array.new
while line=gets
  line.chomp.split(/,/).each{|i|
    a.push i.to_i
  }
end
g = Grid.new(0,a)
ans = g.solve

puts "This quenstion has #{ans} answer[s]."

